﻿using CodeStage.AntiCheat.Detectors;

namespace HutongGames.PlayMaker.Actions
{
	[ActionCategory("Anti-Cheat Toolkit")]
	[Tooltip("Sends an event when a violation is detected.")]
    public class DetectedSpeedHack : FsmStateAction
	{
        [RequiredField]
        [Tooltip("Interval in seconds to check for speed hacks")]
	    public FsmFloat Interval;

	    [RequiredField]
        [Tooltip("Allowed false positives")]
        public FsmInt AllowedFalsePositives;

	    [RequiredField]
        [Tooltip("Allowed false positives")]
        public FsmEvent DetectionEvent;

        public override void Reset()
        {
            Interval = 1f;
            AllowedFalsePositives = 3;
        }

        public override void OnEnter()
        {
            if (DetectionEvent == null) return;
            if (Interval == null || Interval.IsNone) return;
            if (AllowedFalsePositives == null || AllowedFalsePositives.IsNone) return;

            SpeedHackDetector.StartDetection(OnSpeedHackDetected, Interval.Value, (byte)AllowedFalsePositives.Value);
        }

        public override void OnExit()
        {
            SpeedHackDetector.StopMonitoring();
           
            base.OnExit();
        }

        protected void OnSpeedHackDetected()
        {
            Fsm.Event(DetectionEvent);
        }
	}
}
