﻿using CodeStage.AntiCheat.ObscuredTypes;

namespace HutongGames.PlayMaker.Actions
{
	[ActionCategory("Anti-Cheat Toolkit")]
	[Tooltip("Sends an Event when an alteration of a variable type is given")]
    public class DetectedVariableAlteration : FsmStateAction
	{
	    [Tooltip("Interval in seconds to check for speed hacks")]
        public FsmBool MonitorInts = true;

	    [RequiredField]
        [Tooltip("Allowed false positives")]
        public FsmEvent DetectionEvent;

        public override void Reset()
        {
            MonitorInts.Value = true;
            DetectionEvent = null;
        }

        public override void OnEnter()
        {
            if (DetectionEvent == null) return;

            if (MonitorInts.Value)
                ObscuredInt.onCheatingDetected = OnDetection;
        }

        protected void OnDetection()
        {
            Fsm.Event(DetectionEvent);
        }
	}
}