﻿using CodeStage.AntiCheat.ObscuredTypes;

namespace HutongGames.PlayMaker.Actions
{
    [ActionCategory("PlayerPrefs")]
    [Tooltip("Returns the value corresponding to key in the preference file if it exists.")]
    public class PlayerPrefsSetObscuredBool : FsmStateAction
    {
        [CompoundArray("Count", "Key", "Variable")]
        [Tooltip("Case sensitive key.")]
        public FsmString[] Keys;
        [UIHint(UIHint.Variable)]
        public FsmBool[] Variables;

        public override void Reset()
        {
            Keys = new FsmString[1];
            Variables = new FsmBool[1];
        }

        public override void OnEnter()
        {
            for (var i = 0; i < Keys.Length; i++)
            {
                if (Keys[i].IsNone && Keys[i].Value.Equals("")) continue;

                ObscuredPrefs.SetBool(Keys[i].Value, Variables[i].Value);
            }
            Finish();
        }

    }
}